/* =========================================================================================================
  Script ADO GPS - ArmA3
  Version	: 4.0
  Date 		: 03/07/2016
  Auteur	: The-KiLLeR (www.clan-ado.fr)
========================================================================================================= */

// ================================== CONFIGURATIONS ==================================

#define ADO_GPS_leader true 	// Afficher uniquement les chefs de groupes (true = activer | false = dsactiver)
#define ADO_GPS_side 1 			// 0 = Tous les camps | 1 = Son camp uniquement | 2 = Les camps slectionns dans ADO_GPS_side_list 
#define ADO_GPS_list [] 			// Si ADO_GPS_side 2, indiquer la liste des camps  afficher : 0 = EAST | 1 = WEST | 2 = GUER | 3 = CIV (Exemple : WEST + GUER : [1,2] , EAST + GUER + CIV : [0,2,3])

// ================================== NE PAS TOUCHER ==================================

waitUntil { !isNil {player} };
waitUntil { player == player };

#define ADO_GPS_playerSide getNumber(configFile >> "cfgVehicles" >> (typeOf player) >> "side")

sleep 0.5;

private "_list";
_list = [];

while {true} do
{
	private "_playerList";
	_playerList = [];

	if (isMultiplayer) then {
		_playerList = playableUnits;
	} else {
		_playerList = allUnits;
	};
	
	{
		private ["_markerName","_reviveStatus","_side"];
		
		_markerName = format["ADO_GPS_marker_%1",_x];
		_reviveStatus = _x getVariable "ADO_REVIVE_status";
		if (isNil "_reviveStatus") then { _reviveStatus = 0 };
		_side = getNumber(configFile >> "cfgVehicles" >> (typeOf _x) >> "side");
	
		if (((ADO_GPS_side == 0) || ((ADO_GPS_side == 1) && (_side == ADO_GPS_playerSide)) || ((ADO_GPS_side == 2) && (_side in ADO_GPS_list))) && ((ADO_GPS_leader && leader _x == _x) || !ADO_GPS_leader) && _reviveStatus == 0) then 
		{
			private "_color";
			
			_color = "ColorBlue";
			if (player == _x) then { _color = "ColorOrange"; };
			if (_x in (units group player) && (_x != player)) then { _color = "ColorGreen"; };
			
			if (markerType _markerName == "") then
			{
				_marker = createMarkerLocal [_markerName, getPos _x];
				_marker setMarkerTypeLocal "mil_arrow";  
				_marker setMarkerSizeLocal [0.5, 0.5];
				_marker setMarkerColorLocal _color;
				_marker setMarkerTextLocal (name _x);
				_list = _list + [_markerName];
				
			} else {
				
				private ["_dir","_type","_size","_vehicle"];
					
				_dir = getDir _x;
				_type = "mil_arrow";
				_size = [0.5, 0.5];
				_vehicle = vehicle _x;
				
				if(_vehicle != _x) then
				{
					if (((crew _vehicle) select 0 == _x) || ADO_GPS_leader) then
					{
						_dir = 0;
						_size = [0.7, 0.7];
						
						if (_vehicle isKindOf "tank") then { _type = "b_armor"; };
						if (_vehicle isKindOf "plane") then { _type = "b_plane"; };
						if (_vehicle isKindOf "helicopter") then { _type = "b_air"; };		
						if (_vehicle isKindOf "car") then { _type = "b_motor_inf"; };
						if (_vehicle isKindOf "ship") then { _type = "b_naval"; };
					} else {
						_type = "empty";
					};
				};
				
				_markerName setMarkerPosLocal (getPos _x);
				_markerName setMarkerDirLocal _dir;
				_markerName setMarkerTypeLocal _type;
				_markerName setMarkerColorLocal _color;
				_markerName setMarkerSizeLocal _size;
				_markerName setMarkerTextLocal (name _x);
			};
		};
	} forEach _playerList;

	private "_listTemp";
	_listTemp = [];
	{
		_markerName = format["ADO_GPS_marker_%1",_x];
		_reviveStatus = _x getVariable "ADO_REVIVE_status";
		if (isNil "_reviveStatus") then { _reviveStatus = 0 };	
		if (alive _x && _reviveStatus == 0) then { _listTemp = _listTemp + [_markerName]; };
	} forEach _playerList;
	
	{
		if (!(_x in _listTemp)) then { deleteMarkerLocal _x; };
	} forEach _list;
	
	_list = _listTemp;

	sleep 0.5;
};